<?php
function getEntryHits($target, $mother){
	global $database, $owner, $suri, $entryView;
	getEntryHitsTableCheck();
	requireComponent('Textcube.Function.misc');
	if((($suri['directive']=="/" || $suri['directive'] == "/entry") && $suri['value'] != "") && !doesHaveOwnership()) getHitsProcess($mother);
	$hitCount = DBQuery::queryCell("SELECT hits FROM {$database['prefix']}Entries_hits WHERE blogid = {$owner} AND entry = {$mother}");
	$hitCount = ($hitCount)?"{$hitCount}":"";
	$hitsView = "<span id=\"hitsView{$mother}\">view <span class=\"cnt\">{$hitCount}</span></span>";
	misc::dress('HitsView', $hitsView, $entryView);
	return $target;
}

function getHitsProcess($id){
	global $database, $owner, $blogURL;
	$hitsrows = DBQuery::queryCell("SELECT hits FROM {$database['prefix']}Entries_hits WHERE blogid = {$owner} AND entry = {$id}");
	if ($hitsrows){
		if($_COOKIE['entryViewHit'] != getAnonymousSession()){
			DBQuery::execute("UPDATE {$database['prefix']}Entries_hits SET hits = hits+1 WHERE blogid = {$owner} AND entry = {$id}");
			ob_start();
				SetCookie("entryViewHit", getAnonymousSession() , 0, $blogURL."/".$id);
			ob_end_flush();
		}
	}else{
		DBQuery::execute("INSERT INTO {$database['prefix']}Entries_hits values({$owner}, {$id}, 1)");
		ob_start();
			setcookie("entryViewHit", getAnonymousSession() , 0, $blogURL."/".$id);
		ob_end_flush();
	}
	return true;
}

function getHitsRankingEntryList($parameter){
	global $database, $owner, $blog, $pluginURL, $blogURL, $configVal;
	if (isset($parameter['preview'])) {
		// preview mode
		$retval = "글 목록을 조회 순으로 사이드바에 출력해서 보여줍니다.";
		return $retval;
	}
	getEntryHitsTableCheck();
	requireComponent('Textcube.Function.misc');
	$data = misc::fetchConfigVal($configVal);
	if(is_null($data)){
		$data['listLength']		= 5;
		$data['titleLength']	= 25;
		$data['commentView']	= 2;
		$data['dateCheck']		= 2;
		$data['dateLimit']		= "";
		$data['dateStart']		= "";
		$data['dateEnd']		= "";
		$data['rankIcon']		= 1;
		$data['hitsheader']		= "<div class=\"listbox\">\n<h3>hits entry list</h3>";
		$data['hitsfooter']		= "</div>";
	}

	$dateStart	= "";
	$dateEnd	= "";
	$dateLimit	= "";
	$rankicon	= "";
	$i = 0;
	$rep_commtent = "";
	if($data['dateLimit']){
		$dateStart = strtotime(date("Y-m-d",time())." -{$data['dateLimit']} days");
		$dateEnd = time();
	}
	if($data['dateStart'] || $data['dateEnd']){
		$dateStart = ($data['dateStart'])?strtotime($data['dateStart']):"";
		if($data['dateEnd']){
			$dateEnd = (strtolower($data['dateEnd']) == "today")?time():strtotime($data['dateEnd']);
		}else{
			$dateEnd = "";
		}

	}
	if($data['dateCheck'] == 1 && $dateStart && $dateEnd) {
		$dateLimit = " AND (e.published >= ".$dateStart." AND e.published <= ".$dateEnd.") ";
	}
	$dataCnt = DBQuery::queryCell("SELECT COUNT(*) FROM {$database['prefix']}Entries_hits WHERE blogid = {$owner}");
	$data['listLength'] = ($data['listLength'] && $dataCnt)?" LIMIT {$data['listLength']} ":"";
	$visibility = doesHaveOwnership()?'':'AND e.visibility > 0';
	$result = DBQuery::queryAll("SELECT e.id, e.title, e.slogan, e.comments, c.hits, MAX(c.entry) FROM {$database['prefix']}Entries e LEFT JOIN {$database['prefix']}Entries_hits c ON e.id = c.entry AND e.blogid = c.blogid WHERE e.blogid = {$owner} AND e.draft = 0 {$visibility} AND e.category >= 0 AND c.entry IS NOT NULL {$dateLimit} GROUP BY c.entry ORDER BY c.hits DESC {$data['listLength']}");
	$rankicon = ($data['rankIcon'] == 1)?" style=\"margin:4px 0px 0px 0px;padding:0px;list-style:none;margin-left:1px;\"":"";
	$target  = ($data['hitsheader'])?$data['hitsheader']:"<div class=\"listbox\">\n<h3>hits entry list</h3>";
	$target .= "<div id=\"hitsEntry\">\n";
	$target .= "<ul {$rankicon}>\n";
	foreach ($result as $entry){
		$i++;
		$permalink =($blog['useSlogan']?"{$blogURL}/entry/{$entry['slogan']}":$blogURL."/".$entry['id']);
		$rep_title = htmlspecialchars(UTF8::lessenAsEm($entry['title'], $data['titleLength']));
		if($data['commentView'] == 1) $rep_commtent = ($entry['comments'])?"<span class=\"cnt\">({$entry['comments']})</span>":"";
		$rankicon = ($data['rankIcon'] == 1)?" style=\"background:url({$pluginURL}/icon/{$i}.gif) no-repeat 0px 3px;padding-left:13px;\"":"";
		$target .= "<li {$rankicon}><a href=\"{$permalink}\">{$rep_title}</a> {$rep_commtent} </li>\n";
	}
	$target .= "</ul>\n";
	$target .= "</div>\n";
	$target .= ($data['hitsfooter'])?$data['hitsfooter']:"</div>";
	return $target;
}

function getEntryHitsTableCheck(){
	global $database;
	if (DBQuery::queryExistence("DESC {$database['prefix']}Entries_hits id")) {
		DBQuery::execute("ALTER TABLE {$database['prefix']}Entries_hits DROP id");
	}

	if(DBQuery::queryExistence("DESC {$database['prefix']}Entries_hits owner")){ 
		DBQuery::execute("ALTER TABLE {$database['prefix']}Entries_hits CHANGE owner blogid int(11) NOT NULL DEFAULT 0"); 
	} 
}

function HitsRankingEntryListDataSet($data){
	getEntryHitsTableCheck();
	requireComponent('Textcube.Function.misc');
	$cfg = misc::fetchConfigVal($data);
	if($cfg['dateLimit'] && ($cfg['dateStart'] || $cfg['dateEnd'])) return "::입력 오류::\n\n'특정일수'와 '시작/끝날 날짜' 항목은 함께 사용할 수 없습니다.   ";
	if($cfg['dateStart'] && !$cfg['dateEnd']) return "::입력 오류::\n\n'끝날날짜' 항목을 입력하셔야 합니다.   ";
	if(!$cfg['dateStart'] && $cfg['dateEnd']) return "::입력 오류::\n\n'시작날짜' 항목을 입력하셔야 합니다.   ";
	return true;
}
?>